//+------------------------------------------------------------------+
//|                                                    Kir Janja.mq4 |
//|                                                           ljubas |
//+------------------------------------------------------------------+
extern   double alLots    = 0.1;
////////////////////////////////////////////////
string   EA_Tester        = "kirjanja";
int      Magic            = 712506;
bool     Ans              = false;
int      Decimal          = 0;
double   EarnBuy          = 0.00;
double   EarnSell         = 0.00;
double   EarnAll          = 0.00;
datetime LastBuy; 
datetime LastSell; 
double   LastBuyPrice, LastSellPrice, MultiplierBuy, MultiplierSell;
double   M8, M7, M6, M5, M4, M3, M2, M1, M0, S8, S7, S6, S5, S4, S3, S2, S1, S0, Ma0, Ma1, Ma2, Ma3, Ma4, Ma5, Ma6, Ma7, Ma8;
double   laRSI8, laRSI7, laRSI6, laRSI5, laRSI4, laRSI3, laRSI2, laRSI1, laRSI0;               
double   laStoK0, laStoK060, laStoK1, laStoK160, laStoK2, laStoK3, laStoK4, laStoK5, laStoK6, laStoK7, laStoK8, laStoD0, laStoD1, laStoD060, laStoD160, laStoD2, laStoD3, laStoD4, laStoD5, laStoD6, laStoD7, laStoD8;
double   laPSar0, laPSar1, laPSar2, laPSar060, laPSar160, laPSar260 ;
double   laBB00,laBBL0,laBBH0,laBB01,laBBL1,laBBH1,laBB02,laBBL2,laBBH2,laBB03,laBBL3,laBBH3,laBB04,laBBL4,laBBH4,laBB05,laBBL5,laBBH5,laBB06,laBBL6,laBBH6,laBB07,laBBL7,laBBH7,laBB08,laBBL8,laBBH8;
double   laADX00, laADXP0, laADXM0, laADX01, laADXP1, laADXM1, laADX02, laADXP2, laADXM2, laADX03, laADXP3, laADXM3, laADX04, laADXP4, laADXM4, laADX05, laADXP5, laADXM5, laADX06, laADXP6, laADXM6, laADX07, laADXP7, laADXM7, laADX08, laADXP8, laADXM8;
//--------------------------------------------------------------------
int init()
  {  
   LastBuyPrice   = 0.00;
   LastSellPrice  = 0.00; 
   LastBuy        = TimeCurrent()-300; 
   LastSell       = TimeCurrent()-300;
   Decimal        = MarketInfo(Symbol(), MODE_DIGITS);
   MultiplierBuy  = 1;
   MultiplierSell = 1;
   return(0);
}
//--------------------------------------------------------------------
int start()
  {
   //--------------------------------------------------------------------   
   TakeValues();
   //--------------------------------------------------------------------   
   EarnAll  = 0.00;
   EarnBuy  = 0.00;
   EarnSell = 0.00;
   for(int PassAll=0; PassAll<OrdersTotal(); PassAll++)
   {
      OrderSelect(PassAll,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderType() == OP_BUY)  EarnBuy  = EarnBuy  + OrderProfit();
      if (OrderMagicNumber() == Magic && OrderType() == OP_SELL) EarnSell = EarnSell + OrderProfit();
   }
   EarnAll = EarnBuy + EarnSell;
   Comment (CountOrders(Magic,OP_BUY), "    ", CountOrders(Magic,OP_SELL), "    ", EarnBuy, "    ", EarnSell);    
   //--------------------------------------------------------------------   
   //--------------------------------------------------------------------   
   //--------------------------------------------------------------------   
   //if (EarnAll > 100) {
   //  Alert("ALL: ",EarnAll);
   //  FilterOrders(5);
   //}
   if (EarnBuy > 100) {
     Alert("BUY: ",EarnBuy);
     FilterOrders(OP_BUY);
   }
   if (EarnSell > 100) {
     Alert("SELL: ",EarnSell);
     FilterOrders(OP_SELL);
   }
   if (CountOrders(Magic,OP_BUY)  < 1) MultiplierBuy  = 1; // Init 
   if (CountOrders(Magic,OP_SELL) < 1) MultiplierSell = 1; // Init
   //--------------------------------------------------------------------   
   //--------------------------------------------------------------------   
   //--------------------------------------------------------------------   
   // BUYING CONDITIONS
      if(
        CountOrders(Magic,OP_BUY) < 1           && 
        laADXP0 > laADXP1 && 
        laADXP1 > laADXP2 && 
        laADXP0 > laADX00 && 
        laADXP1 > laADX01 && 
        laRSI0 < 70       && 
        laADX00 > 25 
      ) OpenbyBuying(); // Buy first one
      if(
        CountOrders(Magic,OP_BUY) > 0           && 
        CountOrders(Magic,OP_BUY) < 4           && 
        AccountFreeMargin() > 2000              &&
        LastBuyPrice > NormalizeDouble(Ask,Decimal)
      ) OpenbyBuying(); // Buy More To Save Wrong Buy
      //--------------------------------------------------------------------   
      //--------------------------------------------------------------------   
      //--------------------------------------------------------------------   
   // SELLING CONDITIONS
      if(
        CountOrders(Magic,OP_SELL) < 1          &&
        laADXM0 > laADXM1 && 
        laADXM1 > laADXM2 && 
        laADXM0 > laADX00 && 
        laADXM1 > laADX01 && 
        laRSI0 > 30       && 
        laADX00 > 25 
      ) OpenbySelling(); // Sell first one
      if(
        CountOrders(Magic,OP_SELL) > 0          &&
        CountOrders(Magic,OP_SELL) < 4          &&
        AccountFreeMargin() > 2000              &&
        LastSellPrice < NormalizeDouble(Bid,Decimal)
      ) OpenbySelling(); // Sell More To Save Wrong Sell
   //--------------------------------------------------------------------   
   if (AccountFreeMargin() < 500) CheckMargin(Magic); // Save margin
   //--------------------------------------------------------------------   
   return(0);   // Exit start()
  }
//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------
void FilterOrders(int alType)
{
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == Magic) {            
       if (OrderType() == OP_BUY  && (OrderType() == alType || alType == 5)) Ans=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Decimal),2);
       if (OrderType() == OP_SELL && (OrderType() == alType || alType == 5)) Ans=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Decimal),2);
       if (!Ans) Print("OrderSelect failed error code is ",GetLastError());
      }  
   }
   
   if (OP_BUY  == alType) {
     LastBuyPrice       = 0.00;
     MultiplierBuy = 1;
   }else{
     LastSellPrice       = 0.00; 
     MultiplierSell  = 1;
   }

   return(0);
}
//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------
void OpenbyBuying() {
     Alert("Buying ",LastBuyPrice," ",Ask);
     double Iznos = NormalizeDouble(alLots * MultiplierBuy,2);
     MultiplierBuy = MultiplierBuy * 2;
     OrderSend(Symbol(),OP_BUY,Iznos,NormalizeDouble(Ask,Decimal),3,0,0,EA_Tester,Magic);
     //OrderSend(Symbol(),OP_BUY,alLots,NormalizeDouble(Ask,Decimal),3,NormalizeDouble(Bid-150*Point,Decimal),NormalizeDouble(Bid+15*Point,Decimal),EA_Tester,Magic);
     LastBuy = TimeCurrent(); 
     LastBuyPrice = NormalizeDouble(Ask-20*Point,Decimal);
     return(0);
}
//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------
void OpenbySelling() {
     Alert("Selling ",LastSellPrice," ",Bid);
     double Iznos = NormalizeDouble(alLots * MultiplierSell,2);
     MultiplierSell = MultiplierSell * 2;
     OrderSend(Symbol(),OP_SELL,Iznos,NormalizeDouble(Bid,Decimal),3,0,0,EA_Tester,Magic); 
     //OrderSend(Symbol(),OP_SELL,alLots,NormalizeDouble(Bid,Decimal),3,NormalizeDouble(Ask+150*Point,Decimal),NormalizeDouble(Ask-15*Point,Decimal),EA_Tester,Magic); 
     LastSell  = TimeCurrent(); 
     LastSellPrice = NormalizeDouble(Bid+20*Point,Decimal);
     return(0);
}
//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------
int CountOrders(int Magic, int alType)
{
   int _CountOrd;
   _CountOrd=0;
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol()) if(((OrderMagicNumber()==Magic)||Magic==0)&&(alType == OrderType())) _CountOrd++;
   }
   return(_CountOrd);
}
//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------
void CheckMargin(int Magic)
{
   double MaxMinus  = 100000;
   int    MaxType   = -1;
   int    MaxTicker = -1;
   double MaxLots   = -1;
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderProfit() < MaxMinus) {
        MaxMinus  = OrderProfit();
        MaxType   = OrderType();
        MaxTicker = OrderTicket();
        MaxLots   = OrderLots();
      }
   }
   if (MaxTicker >= 0) {
      if (MaxType == OP_SELL) Ans=OrderClose(MaxTicker,MaxLots,NormalizeDouble(Ask,Decimal),2);
                         else Ans=OrderClose(MaxTicker,MaxLots,NormalizeDouble(Bid,Decimal),2);
      if (Ans) Alert("Margin Broken Soon. Closing MaxMinus: ",MaxTicker, " - ",Symbol(), "-", MaxMinus); 
      else Print("OrderSelect failed error code is ",GetLastError());
   }
   return(0);
}
//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------
void TakeValues()
{
   //--------------------------------------------------------------------   
   // ADX, DI+, DI- 9 points
   laADX00 = iADX(NULL,0,14,PRICE_CLOSE,MODE_MAIN,0);
   laADXP0 = iADX(NULL,0,14,PRICE_CLOSE,MODE_PLUSDI,0);
   laADXM0 = iADX(NULL,0,14,PRICE_CLOSE,MODE_MINUSDI,0);
   laADX01 = iADX(NULL,0,14,PRICE_CLOSE,MODE_MAIN,1);
   laADXP1 = iADX(NULL,0,14,PRICE_CLOSE,MODE_PLUSDI,1);
   laADXM1 = iADX(NULL,0,14,PRICE_CLOSE,MODE_MINUSDI,1);
   laADX02 = iADX(NULL,0,14,PRICE_CLOSE,MODE_MAIN,2);
   laADXP2 = iADX(NULL,0,14,PRICE_CLOSE,MODE_PLUSDI,2);
   laADXM2 = iADX(NULL,0,14,PRICE_CLOSE,MODE_MINUSDI,2);
   //--------------------------------------------------------------------   
   // Stochastic 9 points
   laStoK060 = iStochastic(NULL,60,5,3,3,MODE_SMA,0,MODE_MAIN,  0);// 0 bar
   laStoK160 = iStochastic(NULL,60,5,3,3,MODE_SMA,0,MODE_MAIN,  1);// 1 bar
   laStoD060 = iStochastic(NULL,60,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);// 0 bar
   laStoD160 = iStochastic(NULL,60,5,3,3,MODE_SMA,0,MODE_SIGNAL,1);// 1 bar
   laStoK0 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,  0);   // 0 bar
   laStoK1 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,  1);   // 1 bar
   laStoK2 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,  2);   // 2 bar
   laStoK3 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,  3);   // 3 bar
   laStoK4 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,  4);   // 4 bar
   laStoK5 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,  5);   // 5 bar
   laStoK6 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,  6);   // 6 bar
   laStoK7 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,  7);   // 7 bar
   laStoK8 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,  8);   // 8 bar
   laStoD0 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);   // 0 bar
   laStoD1 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,1);   // 1 bar
   laStoD2 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,2);   // 2 bar
   laStoD3 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,3);   // 3 bar
   laStoD4 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,4);   // 4 bar
   laStoD5 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,5);   // 5 bar
   laStoD6 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,6);   // 6 bar
   laStoD7 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,7);   // 7 bar
   laStoD8 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,8);   // 8 bar
   //-------------------------------------------------------------------- 
   // PSar 9 points
   laPSar060 = iSAR(NULL,60,0.02,0.2,0); // 0 bar - 60
   laPSar160 = iSAR(NULL,60,0.02,0.2,1); // 1 bar - 60 
   laPSar260 = iSAR(NULL,60,0.02,0.2,2); // 2 bar - 60 
   laPSar0   = iSAR(NULL,0,0.02,0.2,0);  // 0 bar
   laPSar1   = iSAR(NULL,0,0.02,0.2,1);  // 1 bar
   laPSar2   = iSAR(NULL,0,0.02,0.2,2);  // 2 bar
   //-------------------------------------------------------------------- 
   // BBands
   laBB00 = iBands(NULL,0,20,2,0,PRICE_LOW,MODE_MAIN,0);
   laBBL0 = iBands(NULL,0,20,2,0,PRICE_LOW,MODE_LOWER,0);
   laBBH0 = iBands(NULL,0,20,2,0,PRICE_LOW,MODE_HIGH,0);
   laBB02 = iBands(NULL,0,20,2,0,PRICE_LOW,MODE_MAIN,2);
   laBBL2 = iBands(NULL,0,20,2,0,PRICE_LOW,MODE_LOWER,2);
   laBBH2 = iBands(NULL,0,20,2,0,PRICE_LOW,MODE_HIGH,2);
   //-------------------------------------------------------------------- 
   // MACD, SIGNAL 9 points
   M0=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);   
   M1=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);   
   M2=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,2);    
   M3=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,3);    
   M4=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,4);    
   M5=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,5);   
   M6=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,6);    
   M7=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,7);    
   M8=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,8);    
   S0=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0); 
   S1=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);   
   S2=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,2);   
   S3=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,3);  
   S4=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,4); 
   S5=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,5);   
   S6=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,6);   
   S7=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,7);  
   S8=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,8); 
   //-------------------------------------------------------------------- 
   // RSI 9 points
   laRSI8 = iRSI(NULL,0,14,PRICE_CLOSE,8);
   laRSI7 = iRSI(NULL,0,14,PRICE_CLOSE,7);
   laRSI6 = iRSI(NULL,0,14,PRICE_CLOSE,6);
   laRSI5 = iRSI(NULL,0,14,PRICE_CLOSE,5);
   laRSI4 = iRSI(NULL,0,14,PRICE_CLOSE,4);
   laRSI3 = iRSI(NULL,0,14,PRICE_CLOSE,3);
   laRSI2 = iRSI(NULL,0,14,PRICE_CLOSE,2);
   laRSI1 = iRSI(NULL,0,14,PRICE_CLOSE,1);
   laRSI0 = iRSI(NULL,0,14,PRICE_CLOSE,0);
   //-------------------------------------------------------------------- 
   return(0);
}